(* ------------------------------------------------------ *)
(*                    JRTSTRNG.PAS                        *)
(*             Leerstrings in JRT Pascal                  *)
(*         (c) by Michael Haardt und TOOLBOX              *)
(* ------------------------------------------------------ *)
PROGRAM String_Test;

TYPE LongStr = RECORD
                 CASE INTEGER OF
                   1: (str: STRING[65535]);
                   2: (mem: INTEGER);
               END;

VAR  s1, s2, s3: STRING[20];
     i         : INTEGER;

PROCEDURE Nul(VAR s: LongStr);
BEGIN
  s.mem := 0;
END;

PROCEDURE DeleteStr(VAR s: LongStr; p1, p2: INTEGER);
BEGIN
  IF (p1=1) AND (Length(s.str)=p2) THEN
    Nul(s)
  ELSE
    Delete(s.str, p1, p2);
END;

BEGIN
  s1 := `Test'; Nul(s2); s3 := s2;
  FOR i:=1 TO 4 DO BEGIN
    WriteLn(s1, Length(s1),' ',s2, Length(s2),' ',
            s3, Length(s3),' ',s1);
    DeleteStr(s1, 1, 1);
    s2 := Concat(s2,'!'); s3 := s2;
  END;
  WriteLn(s1, Length(s1),' ',s2, Length(s2),' ',
          s3, Length(s3),' ',s1);
END.
(* ------------------------------------------------------ *)
(*                 Ende von JRTSTRNG.PAS                  *)